Subject: Re: [PATCH -next] usb: add usb.h stubs for CONFIG_USB not enabled

From: Randy Dunlap <[email-masked]>
Date: Sat, 19 May 2012 08:48:52 -0700

On 05/19/2012 07:30 AM, Alan Stern wrote:

> On Fri, 18 May 2012, Randy Dunlap wrote:
> 
>> From: Randy Dunlap <[email-masked]>
>>
>> Add stubs for some usb core functions when CONFIG_USB
>> is not enabled.  This fixes these comedi build errors:
>>
>> ERROR: "usb_deregister" [drivers/staging/comedi/comedi.ko] undefined!
>> ERROR: "usb_register_driver" [drivers/staging/comedi/comedi.ko] undefined!
>>
>> Signed-off-by: Randy Dunlap <[email-masked]>
>> ---
>> I am only adding the stubs that are needed for comedi to build.
>> I expect that more stubs will be needed as more build errors are
>> found.  It seems to me that linux/usb.h might need more (major)
>> moving of lines to support more stubs in the future.
> 
> This doesn't seem like the right thing to do.  If a driver needs to 
> register with the USB core then that driver should depend on 
> CONFIG_USB.
> 
> On the other hand, if the driver is capable of being built without USB 
> support then it should use the necessary preprocessor tests to protect 
> calls to any USB routines.

Yeah, my first patch (not on linux-usb list) to staging/comedi/drivers.c
just surrounded the usb helper functions with IS_ENABLED(CONFIG_USB).
I'm fine with that patch, but Greg said that he wanted stubs...

-- 
~Randy